library bubbles;
import 'package:flutter/material.dart';
import 'dart:math';

/// A Calculator.
class Bubbles extends StatefulWidget {
  Bubbles({Key key}) : super(key: key);

  @override
  _BubblesState createState() => _BubblesState();
}

class _BubblesState extends State<Bubbles> with TickerProviderStateMixin {
  final double largeCardSize = 112.0;
  final double smallCardSize = 88.0;
  final double cardGap = 8.0;
  final double containerGap = 12.0;

  List<int> list1 = [1,9,2,3,4,5,6,7,8];
  List<int> list2 = [10,11,18,12,13,14,15,16,17];

  AnimationController _controller1;
  Animation<double> _largeToSmall1;
  Animation<double> _smallToLarge1;
  Animation<double> _zeroToSmall1;
  Animation<double> _zeroToSmall1Margin;
  Animation<double> _line1Bounce;

  AnimationController _controller2;
  Animation<double> _largeToSmall2;
  Animation<double> _smallToLarge2;
  Animation<double> _zeroToLarge2;
  Animation<double> _zeroToSmall2Margin;
  Animation<double> _line2Bounce;

  Color randomColor() {
    // return Color.fromARGB(255, Random().nextInt(256) + 0, Random().nextInt(256) + 0, Random().nextInt(256) + 0);
    return Color.fromARGB(255, 0, 0, 0);
  }

  void _play() {
    _controller1.stop();
  }

  @override void initState() {
    super.initState();
    // 第一行动画控制器
    _controller1 = AnimationController(
      vsync: this,
      duration: Duration(milliseconds: 1000),
    );

    _zeroToSmall1 = TweenSequence(
      <TweenSequenceItem<double>>[
        TweenSequenceItem<double>(
          tween: Tween<double>(begin: 0, end: smallCardSize * 1.2,),
          weight: 55.0
        ),
        TweenSequenceItem<double>(
          tween: Tween<double>(begin: smallCardSize * 1.2, end: smallCardSize,),
          weight: 15.0
        ),
        TweenSequenceItem<double>(
          tween: Tween<double>(begin: smallCardSize, end: smallCardSize * 0.8,),
          weight: 15.0
        ),
        TweenSequenceItem<double>(
          tween: Tween<double>(begin: smallCardSize * 0.8, end: smallCardSize,),
          weight: 15.0
        ),
      ]
    ).animate(
      CurvedAnimation(
        parent: _controller1,
        curve: Curves.linear,
      ),
    );

    _line1Bounce = TweenSequence(
      <TweenSequenceItem<double>>[
        TweenSequenceItem<double>(
          tween: Tween<double>(begin: 0, end: -smallCardSize * 0.6),
          weight: 50.0,
        ),
        TweenSequenceItem<double>(
          tween: Tween<double>(begin: -smallCardSize * 0.6, end: 0),
          weight: 50.0,
        ),
      ]
    ).animate(
      CurvedAnimation(
        parent: _controller1,
        curve: Curves.linear,
      ),
    );

    _zeroToSmall1Margin = Tween<double>(
      begin: 0,
      end: cardGap / 2,
    ).animate(
      CurvedAnimation(
        parent: _controller1,
        curve: Curves.linear,
      ),
    );

    _largeToSmall1 = Tween<double>(
      begin: largeCardSize,
      end: smallCardSize,
    ).animate(
      CurvedAnimation(
        parent: _controller1,
        curve: Curves.linear,
      ),
    );

    _smallToLarge1 = Tween<double>(
      begin: smallCardSize,
      end: largeCardSize,
    ).animate(
      CurvedAnimation(
        parent: _controller1,
        curve: Curves.linear,
      ),
    );

    // 第二行动画控制器
    _controller2 = AnimationController(
      vsync: this,
      duration: Duration(milliseconds: 1000),
    );

    _zeroToLarge2 = TweenSequence(
      <TweenSequenceItem<double>>[
        TweenSequenceItem<double>(
          tween: Tween<double>(begin: 0, end: largeCardSize * 1.2,),
          weight: 55.0
        ),
        TweenSequenceItem<double>(
          tween: Tween<double>(begin: largeCardSize * 1.2, end: largeCardSize,),
          weight: 15.0
        ),
        TweenSequenceItem<double>(
          tween: Tween<double>(begin: largeCardSize, end: largeCardSize * 0.8,),
          weight: 15.0
        ),
        TweenSequenceItem<double>(
          tween: Tween<double>(begin: largeCardSize * 0.8, end: largeCardSize,),
          weight: 15.0
        ),
      ]
    ).animate(
      CurvedAnimation(
        parent: _controller2,
        curve: Curves.linear,
      ),
    );

    _line2Bounce = TweenSequence(
      <TweenSequenceItem<double>>[
        TweenSequenceItem<double>(
          tween: Tween<double>(begin: 0, end: -largeCardSize * 0.6),
          weight: 50.0,
        ),
        TweenSequenceItem<double>(
          tween: Tween<double>(begin: -largeCardSize * 0.6, end: 0),
          weight: 50.0,
        ),
      ]
    ).animate(
      CurvedAnimation(
        parent: _controller2,
        curve: Curves.linear,
      ),
    );

    _zeroToSmall2Margin = Tween<double>(
      begin: 0,
      end: cardGap / 2,
    ).animate(
      CurvedAnimation(
        parent: _controller2,
        curve: Curves.linear,
      ),
    );

    _largeToSmall2 = Tween<double>(
      begin: largeCardSize,
      end: smallCardSize,
    ).animate(
      CurvedAnimation(
        parent: _controller2,
        curve: Curves.linear,
      ),
    );

    _smallToLarge2 = Tween<double>(
      begin: smallCardSize,
      end: largeCardSize,
    ).animate(
      CurvedAnimation(
        parent: _controller2,
        curve: Curves.linear,
      ),
    );
    // 动画启动
    _controller1.addStatusListener((status) {
      if (status == AnimationStatus.completed) {
        if (_controller2.isCompleted) {
          Future.delayed(Duration(milliseconds: 1500), () {
            setState(() {
              list2.insert(2, list2.removeLast());
            });
            _controller2.reset();
            _controller2.forward();
          });
        } else {
          Future.delayed(Duration(milliseconds: 1500), () {
            _controller2.forward();
          });
        }
      }
    });

    _controller2.addStatusListener((status) {
      if (status == AnimationStatus.completed) {
        Future.delayed(Duration(milliseconds: 1500), () {
          setState(() {
            list1.insert(1, list1.removeLast());
          });
          _controller1.reset();
          _controller1.forward();
        });
      }
    });

    _controller1.forward();
  }
  
  @override 
  Widget build(BuildContext context) {
    List<Widget> listWidget1 = [];
    List<Widget> listWidget2 = [];

    // 第一个widget行处理
    for(var i = 0; i < list1.length; i++) {
      listWidget1.add(
        AnimatedBuilder(
          animation: _controller1,
          builder: (BuildContext context, Widget child) { 
            return Container(
              margin: () {
                if (i == 1) {
                  return EdgeInsets.only(left: _zeroToSmall1Margin.value, right: _zeroToSmall1Margin.value);
                } else {
                  return EdgeInsets.only(left: cardGap / 2, right: cardGap / 2);
                }
              } (),
              width: () { 
                double size;
                switch (i) {
                  case 0: 
                    size = largeCardSize;
                    break;
                  case 1: 
                    size = _zeroToSmall1.value;
                    break;
                  default:
                    size = i % 3 == 0 ? _smallToLarge1.value : (i % 3 == 1 ? _largeToSmall1.value : smallCardSize);
                }
                return size;
              } (),
              height: () { 
                double size;
                switch (i) {
                  case 0: 
                    size = largeCardSize;
                    break;
                  case 1: 
                    size = _zeroToSmall1.value;
                    break;
                  default:
                    size = i % 3 == 0 ? _smallToLarge1.value : (i % 3 == 1 ? _largeToSmall1.value : smallCardSize);
                }
                return size;
              } (),
              decoration: BoxDecoration(
                color: randomColor(),
                borderRadius: BorderRadius.all(Radius.circular(20.0)),
              ),
              child: Center(
                child: Text(list1[i].toString(), style: TextStyle(
                  fontSize: 24.0,
                  color: Color(0xFFFFFFFF)
                )),
              ),
            );
          },
        )
      );
    }

    // 第二个widget行处理
    for(var i = 0; i < list2.length; i++) {
      listWidget2.add(
        AnimatedBuilder(
          animation: _controller2,
          builder: (BuildContext context, Widget child) { 
            return Container(
              margin: () {
                if (i == 2) {
                  return EdgeInsets.only(left: _zeroToSmall2Margin.value, right: _zeroToSmall2Margin.value);
                } else {
                  return EdgeInsets.only(left: cardGap / 2, right: cardGap / 2);
                }
              } (),
              width: () {
                double size;
                switch (i) {
                  case 0:
                  case 1:
                    size = smallCardSize;
                    break;
                  case 2:
                    size = _zeroToLarge2.value;
                    break;
                  default:
                    size = i % 3 == 0 ? _largeToSmall2.value : (i % 3 == 1 ? smallCardSize : _smallToLarge2.value);
                }
                return size;
              } (),
              height: () {
                double size;
                switch (i) {
                  case 0:
                  case 1:
                    size = smallCardSize;
                    break;
                  case 2:
                    size = _zeroToLarge2.value;
                    break;
                  default:
                    size = i % 3 == 0 ? _largeToSmall2.value : (i % 3 == 1 ? smallCardSize : _smallToLarge2.value);
                }
                return size;
              } (),
              decoration: BoxDecoration(
                color: randomColor(),
                borderRadius: BorderRadius.all(Radius.circular(20.0)),
              ),
              child: Center(
                child: Text(list2[i].toString(), style: TextStyle(
                  fontSize: 24.0,
                  color: Color(0xFFFFFFFF)
                )),
              ),
            );
          },
        )
      );
    }

    return Column(
      children: [
        SingleChildScrollView(
          padding: EdgeInsets.only(left: containerGap - cardGap / 2, right: containerGap - cardGap / 2, top: containerGap, bottom: containerGap),
          scrollDirection: Axis.horizontal,
          child: Stack(
            alignment: AlignmentDirectional.topStart,
            children: [
              Container(
                width: (list1.length / 3) * (smallCardSize * 2 + largeCardSize) + list1.length * cardGap,
                height: smallCardSize + largeCardSize + cardGap,
              ),
              AnimatedBuilder(
                animation: _controller1,
                builder: (BuildContext context, Widget child) { 
                  return Positioned(
                    left: _line1Bounce.value,
                    child: Container(
                      height: cardGap + smallCardSize + largeCardSize,
                      child: Row(
                        crossAxisAlignment: CrossAxisAlignment.start,
                        children: listWidget1,
                      ),
                    ),
                  );
                },
              ),
              AnimatedBuilder(
                animation: _controller2,
                builder: (BuildContext context, Widget child) { 
                  return Positioned(
                    top: smallCardSize + cardGap + largeCardSize - largeCardSize * 1.2,
                    left: _line2Bounce.value,
                    child: Container(
                      height: largeCardSize * 1.2,
                      child: Row(
                        crossAxisAlignment: CrossAxisAlignment.end,
                        children: listWidget2,
                      ),
                    ),
                  );
                },
              ),
            ],
          ),
        ),
        FloatingActionButton(
          onPressed: _play,
          child: Icon(Icons.refresh),
        ),
      ]
    );
  }
}
